package javax.imageio.spi;

import java.util.HashMap;
import java.util.Map;
import java.util.LinkedList;
import java.util.Iterator;

class PartialOrderIterator implements Iterator
{
    LinkedList zeroList;
    Map inDegrees;
    
    public PartialOrderIterator(Iterator iterator) {
        this.zeroList = new LinkedList();
        this.inDegrees = new HashMap();
        while (iterator.hasNext()) {
            DigraphNode e = (DigraphNode)iterator.next();
            int inDegree = e.getInDegree();
            this.inDegrees.put(e, new Integer(inDegree));
            if (inDegree == 0) {
                this.zeroList.add(e);
            }
            else {
                continue;
            }
        }
    }
    
    @Override
    public boolean hasNext() {
        return !this.zeroList.isEmpty();
    }
    
    @Override
    public Object next() {
        DigraphNode digraphNode = (DigraphNode)this.zeroList.removeFirst();
        Iterator<Object> outNodes = digraphNode.getOutNodes();
        while (outNodes.hasNext()) {
            DigraphNode e = (DigraphNode)outNodes.next();
            int value = (int)this.inDegrees.get(e) - 1;
            this.inDegrees.put(e, new Integer(value));
            if (value == 0) {
                this.zeroList.add(e);
            }
            else {
                continue;
            }
        }
        return digraphNode.getData();
    }
    
    @Override
    public void remove() {
        throw new UnsupportedOperationException();
    }
}
